package cz.cvut.k36.pr2.hw.hw02.test;

import cz.cvut.k36.pr2.hw.hw02.Color;
import cz.cvut.k36.pr2.hw.hw02.RGB;
import cz.cvut.k36.pr2.hw.hw02.impl.CMYK;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

public class CMYKTest {

    public static void main(String[] args) throws IOException {
        final BufferedImage image = ImageIO.read(new File("resources/fel.jpg"));

        final int height = image.getHeight();
        final int width = image.getWidth();
        ArrayBackedCanvas canvase = new ArrayBackedCanvas(width, height);
        for (int x = 0; x < width; x++) {
            for (int y = 0; y < height; y++) {
                java.awt.Color awtColor = new java.awt.Color(image.getRGB(x, y));
                Color color = new Color(awtColor.getRed(), awtColor.getGreen(), awtColor.getBlue());
                canvase.setColorAt(x, height - y - 1, color);
            }
        }

        canvase.setInk(RGB.RED);
        canvase.writeToFile("fel-red.png");

        canvase.setInk(RGB.GREEN);
        canvase.writeToFile("fel-green.png");

        canvase.setInk(RGB.BLUE);
        canvase.writeToFile("fel-blue.png");


        //CMYK
        canvase.setInk(CMYK.CYAN);
        canvase.writeToFile("fel-cyan.png");

        canvase.setInk(CMYK.MAGENTA);
        canvase.writeToFile("fel-magenta.png");

        canvase.setInk(CMYK.YELLOW);
        canvase.writeToFile("fel-yellow.png");

        canvase.setInk(CMYK.KEY);
        canvase.writeToFile("fel-key.png");
    }

}
