package cz.cvut.k36.pr2.hw.hw02.test;

import cz.cvut.k36.pr2.hw.hw02.Color;
import cz.cvut.k36.pr2.hw.hw02.RGB;
import cz.cvut.k36.pr2.hw.hw02.ShapeHolder;
import cz.cvut.k36.pr2.hw.hw02.impl.*;

import java.io.IOException;

public class Test {

    public static void main(String[] args) throws IOException {
        Color red = new Color(255, 0, 0);
        Color green = new Color(0, 255, 0);
        Color yellow = new Color(241, 241, 56);
        Color blue = new Color(0, 0, 255);

        ShapeHolder holder = new ShapeHolderImpl();

        holder.addShape(new Rectangle(red, 10, 10, 50, 60));

        holder.addShape(new Circle(yellow, 250, 250, 100));
        holder.addShape(new Circle(blue, 210, 290, 15));
        holder.addShape(new Circle(blue, 290, 290, 15));

        generateArc(holder, blue);

        ArrayBackedCanvas c = new ArrayBackedCanvas(500, 500);
        holder.printToCanvas(c);
        c.writeToFile("test.png");

        c.setInk(RGB.RED);
        c.writeToFile("test-red.png");

        c.setInk(RGB.GREEN);
        c.writeToFile("test-green.png");

        c.setInk(RGB.BLUE);
        c.writeToFile("test-blue.png");


        //CMYK
        c.setInk(CMYK.CYAN);
        c.writeToFile("test-cyan.png");

        c.setInk(CMYK.MAGENTA);
        c.writeToFile("test-magenta.png");

        c.setInk(CMYK.YELLOW);
        c.writeToFile("test-yellow.png");

        c.setInk(CMYK.KEY);
        c.writeToFile("test-key.png");
    }

    private static void generateArc(ShapeHolder holder, Color color) {
        final double step = Math.PI/16d;
        final double radius = 75;

        for (double angle = Math.PI + 2*step; angle < 2 * Math.PI; angle += step) {
            double startX = radius * Math.cos(angle - step) + 250;
            double startY = radius * Math.sin(angle - step) + 250;

            double endX = radius * Math.cos(angle) + 250;
            double endY = radius * Math.sin(angle) + 250;

            holder.addShape(new Line(color, startX, startY, endX, endY));
        }
    }

}
